
import mko575.Utils

/*
 * This file was generated by the Gradle 'init' task.
 *
 * This generated file contains a sample Gradle plugin project to get you started.
 * For more details on writing Custom Plugins, please refer to https://docs.gradle.org/8.7/userguide/custom_plugins.html in the Gradle documentation.
 */

plugins {
    id("project-configuration.IDE")

    // Apply the Java Gradle plugin development plugin to add support for developing Gradle plugins
    `java-gradle-plugin`

    // Apply the Kotlin JVM plugin to add support for Kotlin.
    // Inserted by the Gradle 'init' task: replaces the kotlin-dsl plugin call ?
    alias(libs.plugins.jvm)
    // Licensing, see:
    //  - https://github.com/hierynomus/license-gradle-plugin
    //  - https://github.com/CadixDev/licenser
    //  - https://github.com/diffplug/spotless

    // Apply the publish plugin
    id("com.gradle.plugin-publish") version "1.2.1"
    // For how to publish to the Gradle Plugin Portal see:
    //   https://docs.gradle.org/current/userguide/publishing_gradle_plugins.html#publishing_portal
}

repositories {
    // Use Maven Central for resolving dependencies.
    mavenCentral()
}

// Switching to version 21 (anywhere) causes errors when using the plugin in another project ???
java {
    toolchain {
        // languageVersion = JavaLanguageVersion.of(21)
    }
    // sourceCompatibility = JavaVersion.VERSION_21
    // targetCompatibility = JavaVersion.VERSION_21
}

/**
 * Sourcesets declarations
 */

// Configure test supports as unit tests
val testUtilitiesSourceSet: SourceSet = sourceSets.create("testUtilities") {
    val ssRoot = "src/tests/testUtilities"
    kotlin.setSrcDirs(listOf("$ssRoot/kotlin"))
    resources.setSrcDirs(listOf("$ssRoot/resources"))
}
val testUtilitiesImplementation: Configuration =
    configurations["testUtilitiesImplementation"].extendsFrom(configurations["implementation"])
val testUtilitiesRuntimeOnly: Configuration =
    configurations["testUtilitiesRuntimeOnly"].extendsFrom(configurations["runtimeOnly"])

// Move test sourceset
sourceSets.test {
    val ssRoot = "src/tests/unitTests"
    kotlin.setSrcDirs(listOf("$ssRoot/kotlin"))
    resources.setSrcDirs(listOf("$ssRoot/resources"))
}

// Configure functional tests as unit tests
val functionalTestSourceSet: SourceSet = sourceSets.create("functionalTest") {
    val ssRoot = "src/tests/functionalTests"
    kotlin.setSrcDirs(listOf("$ssRoot/kotlin"))
    resources.setSrcDirs(listOf("$ssRoot/resources"))
}
val functionalTestImplementation: Configuration =
    configurations["functionalTestImplementation"].extendsFrom(configurations["testImplementation"])
val functionalTestRuntimeOnly: Configuration =
    configurations["functionalTestRuntimeOnly"].extendsFrom(configurations["testRuntimeOnly"])

/**
 * Dependencies declarations
 */

dependencies {
    configurations["testUtilitiesImplementation"](gradleApi()) 
        ?.because("Tests support classes call Gradle API functions.")
    configurations["testUtilitiesImplementation"](gradleTestKit())
        ?.because("Test support classes rely on Gradle test kit features.")
    testUtilitiesImplementation(sourceSets["main"].output)
        ?.because("Test support classes directly rely on main project code.")

    testImplementation(sourceSets["main"].output)
        ?.because("Tests obviously rely on main project code.")
    testImplementation("org.assertj:assertj-core:3.25.3")
        ?.because("For improved assertions")
    // Use the Kotlin JUnit 5 integration.
    testImplementation("org.jetbrains.kotlin:kotlin-test-junit5")
        ?.because("Tests (written in Kotlin) call JUnit5 functions.")
    testImplementation(testUtilitiesSourceSet.output)
        ?.because("Tests (in general) rely on shared test support classes.")

    testRuntimeOnly("org.junit.platform:junit-platform-launcher")
        ?.because("Tests (in general) rely on the JUnit platform at runtime.")
}

/**
 * Plugins configuration
 */

Utils.pluginInfoFile =
    layout.projectDirectory
        .file("src/main/kotlin/io/gitlab/mko_utilities/gradle_plugins/less/PluginInfo.kt")
        .asFile

val pluginOwnerId = Utils.getPluginInfo("PLUGIN_OWNER_ID")
val pluginName = Utils.getPluginInfo("PLUGIN_NAME")
val pluginPackage = Utils.fromSubProjOrRootProj(project, "Package")
val pluginVersion = Utils.getPluginInfo("PLUGIN_VERSION")

val lcPluginName: String = pluginName.lowercase()
val pluginIdSeed: String =
        "${pluginOwnerId}.${lcPluginName}"
                .replace(("[\\s_]+").toRegex(),"-")
                .replace(("[^\\w\\d.-]+").toRegex(), "")
                .replace(("\\.+").toRegex(), ".")

logger.quiet(
        "Configuring build for plugin '${pluginName}' (${pluginIdSeed} v${pluginVersion})" +
                " of '${pluginOwnerId}' in package '${pluginPackage}'"
)

version = pluginVersion
group = pluginOwnerId

gradlePlugin {
    website.set("https://gitlab.com/mko-utilities/gradle-plugins/less")
    vcsUrl.set("https://gitlab.com/mko-utilities/gradle-plugins/less.git")

    // Define the plugin
    // val basePlugin by plugins.creating { ... }

    plugins {
        create("${lcPluginName}Base") {
            id = "${pluginIdSeed}-base"
            displayName = "Gradle Base Plugin for Less"
            description = "Defines tasks to process Less files."
            tags.set(listOf("Less", "CSS", "HTML"))
            implementationClass = "${pluginPackage}.${pluginName}BasePlugin"
        }
        create(lcPluginName) {
            id = pluginIdSeed
            displayName = "Gradle Plugin for Less"
            description = "Provides a default configuration to use Less processing tasks."
            tags.set(listOf("Less", "CSS", "HTML"))
            implementationClass = "${pluginPackage}.${pluginName}Plugin"
        }
    }
}

/**
 * TESTING
 */

// Declare that unit tests uses JUnit
tasks.named<Test>("test") {
    // Use JUnit Jupiter for unit tests.
    useJUnitPlatform()
}

gradlePlugin.testSourceSets.add(functionalTestSourceSet)

// Add a task to run the functional tests
val functionalTest by tasks.registering(Test::class) {
    testClassesDirs = functionalTestSourceSet.output.classesDirs
    classpath = functionalTestSourceSet.runtimeClasspath
    useJUnitPlatform()
}

// Configure the 'check' task
tasks.named<Task>("check") {
    // Run the functional tests as part of `check`
    dependsOn(functionalTest)
}

/**
 * PUBLISHING
 */

val gradleUserHome: File = project.gradle.gradleUserHomeDir
val mkoRegistryDeployToken: String by project
publishing {
    repositories {
        maven {
            name = "Local"
            url = uri("${gradleUserHome}/local-plugin-repository")
        }
        maven {
            name = "GitLab"
            url = uri("https://gitlab.com/api/v4/projects/46224752/packages/maven")
            credentials(HttpHeaderCredentials::class) {
                name = "Deploy-Token"
                value = mkoRegistryDeployToken
            }
            authentication {
                create<HttpHeaderAuthentication>("header")
            }
        }
    }
}
